;;
;; USB-Linker for GBC/GBP
;;
;; (C) 2003 Mootan
;;
; 2003.02.10 Mootan
;			First coding.
;
;to do:
;  ack handling for multiboot
;  power on sense
;
;	.globl	_asm_func_PARM_1	; Parameter name
	.globl	_reset_port			; Function name
	.globl	_set_ai				; Function name
	.globl	_write_data			; Function name
	.globl	_read_data			; Function name
;
	.area OSEG

;	_asm_func_PARM_1:	.ds	1	; Parameter decleration
;
	.area XSEG
;
;
;---------- GIPO SFR ----------
_PORTACFG	=	0x7f93
_PORTBCFG	=	0x7f94
_PORTCCFG	=	0x7f95
_OUTA	=	0x7f96
_OUTB	=	0x7f97
_OUTC	=	0x7f98
_PINSA	=	0x7f99
_PINSB	=	0x7f9a
_PINSC	=	0x7f9b
_OEA	=	0x7f9c
_OEB	=	0x7f9d
_OEC	=	0x7f9e
AUTODATA=   0x7fe5
;
;-------------------- Interface Port Assign --------------------
;
DATA_DIR	= _OEB
DATA_OUTP	= _OUTB
DATA_INP	= _PINSB
CTRL_DIR	= _OEC
CTRL_OUTP	= _OUTC
CTRL_INP	= _PINSC
;
NINTR		= acc.0		; PC0
NWAIT		= acc.1		; PC1
PE			= acc.2		; PC2 (User defined)
SELECT		= acc.3		; PC3 (User defined)
WRITE		= 0x10		; PC4
DATASTB		= 0x20		; PC5
RESET		= 0x40		; PC6
ADDRSTB		= 0x80		; PC7
CTRL_IDLE	= (WRITE | DATASTB | ADDRSTB)
NWRITE		= (DATASTB | ADDRSTB)
NDSTB		= (WRITE | ADDRSTB)
NRESET		= (WRITE | RESET | DATASTB | ADDRSTB)
NASTB		= (WRITE | DATASTB)
CTRL_OE		= (WRITE | RESET | DATASTB | ADDRSTB)
;
TIMEOUT		= 100
;
; LED's port
LED_EN		= _OEA
LED_PORT	= _OUTA
DIR_WLED	= 0x20		; WLED=0,RLED=Z
DIR_RLED	= 0x10		; WLED=Z,RLED=0
DIR_BLED	= DIR_WLED | DIR_RLED	; WLED=0,RLED=0
DIR_ZLED	= 0x00		; WLED=Z,RLED=Z
OUT_BLED	= 0x00		; Low Active
;
	.area CSEG
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
_reset_port:
	mov		dptr,#CTRL_OUTP
	mov		a,#NRESET
	movx	@dptr,a				; Reset port
	mov		dptr,#CTRL_DIR
	mov		a,#CTRL_OE
	movx	@dptr,a
	mov		dptr,#DATA_OUTP
	clr		a
	movx	@dptr,a
	mov		dptr,#DATA_DIR
	movx	@dptr,a
	mov		dptr,#LED_PORT
	mov		a,#OUT_BLED
	movx	@dptr,a
	mov		dptr,#LED_EN
	mov		a,#DIR_ZLED
	movx	@dptr,a
	mov		dptr,#CTRL_OUTP
	mov		a,#CTRL_IDLE
	movx	@dptr,a
	ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
_set_ai:
	mov		r0,dpl
	mov		r7,#TIMEOUT
	mov		dptr,#CTRL_INP
_set_ai_loop1:
	movx	a,@dptr
	jnb		NWAIT,_set_ai_1		; NWAIT == 0
	djnz	r7,_set_ai_loop1
	ret
_set_ai_1:
	mov		dptr,#CTRL_OUTP
	mov		a,#NWRITE
	movx	@dptr,a				; NWRITE is asserted
	mov		dptr,#DATA_OUTP
	mov		a,r0
	movx	@dptr,a				; Put address
	mov		dptr,#DATA_DIR
	mov		a,#0xFF
	movx	@dptr,a				; DataBus is output
	mov		dptr,#CTRL_OUTP
	mov		a,#NWRITE & NASTB
	movx	@dptr,a				; NASTB is asserted
	mov		r7,#TIMEOUT
	mov		dptr,#CTRL_INP
_set_ai_loop2:
	movx	a,@dptr
	jb		NWAIT,_set_ai_2
	djnz	r7,_set_ai_loop2
_set_ai_2:
	mov		dptr,#CTRL_OUTP
	mov		a,#NWRITE
	movx	@dptr,a				; NASTB is disasserted
	mov		dptr,#DATA_DIR
	clr		a
	movx	@dptr,a				; DataBus is input
	mov		dptr,#CTRL_OUTP
	mov		a,#CTRL_IDLE
	movx	@dptr,a				; Idle state
	ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
_write_data:
	mov		r0,dpl
	mov		r7,#TIMEOUT
	mov		dptr,#CTRL_INP
_wdata_loop1:
	movx	a,@dptr
	jnb		NWAIT,_wdata_1		; NWAIT == 0
	djnz	r7,_wdata_loop1
	ret
_wdata_1:
	mov		dptr,#CTRL_OUTP
	mov		a,#NWRITE
	movx	@dptr,a				; NWRITE is asserted
	mov		dptr,#DATA_OUTP
	mov		a,r0
	movx	@dptr,a				; Put data
	mov		dptr,#DATA_DIR
	mov		a,#0xFF
	movx	@dptr,a				; DataBus is output
	mov		dptr,#CTRL_OUTP
	mov		a,#NWRITE & NDSTB
	movx	@dptr,a				; NDSTB is asserted
	mov		r7,#TIMEOUT
	mov		dptr,#CTRL_INP
_wdata_loop2:
	movx	a,@dptr
	jb		NWAIT,_wdata_2
	djnz	r7,_wdata_loop2
_wdata_2:
	mov		dptr,#CTRL_OUTP
	mov		a,#NWRITE
	movx	@dptr,a				; NDSTB is disasserted
	mov		dptr,#DATA_DIR
	clr		a
	movx	@dptr,a				; DataBus is input
	mov		dptr,#CTRL_OUTP
	mov		a,#CTRL_IDLE
	movx	@dptr,a				; Idle state
	ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
_read_data:
	mov		r7,#TIMEOUT
	mov		dptr,#CTRL_INP
_rdata_loop1:
	movx	a,@dptr
	jnb		NWAIT,_rdata_1		; NWAIT == 0
	djnz	r7,_rdata_loop1
	ret
_rdata_1:
	mov		dptr,#DATA_DIR
	clr		a
	movx	@dptr,a				; DataBus is input
	mov		dptr,#CTRL_OUTP
	mov		a,#CTRL_IDLE
	movx	@dptr,a				; NWRITE is disasserted
	mov		dptr,#CTRL_OUTP
	mov		a,#NDSTB
	movx	@dptr,a				; NDSTB is asserted
	mov		r7,#TIMEOUT
	mov		dptr,#CTRL_INP
_rdata_loop2:
	movx	a,@dptr
	jb		NWAIT,_rdata_2
	djnz	r7,_rdata_loop2
_rdata_2:
	mov		dptr,#DATA_INP
	movx	a,@dptr				; Get data
	mov		r0,a
	mov		dptr,#CTRL_OUTP
	mov		a,#CTRL_IDLE
	movx	@dptr,a				; NDSTB is disasserted
	mov		dpl,r0
	ret
;
