// USB Linker Header file
//
// USB-Linker for GBx
//
// (C) 2003 Mootan

#define NO_CHECK		1
// Vender ID & Product ID should be defined in here !
// 0x0547 Cypress
#define VENDER_ID_HIGH	0x05
#define VENDER_ID_LOW	0x47

// 0x1002	EZ-USB sample device
#define PRODUCT_ID_HIGH	0x10
#define PRODUCT_ID_LOW	0x02

// Global Variable
unsigned long gFileSize;		// (file size + 3) / 4
unsigned long gAddress;
unsigned char gUpLoadFlag;		// 0:down load	1:up load
unsigned char gAccessType;		// 0:ROM	1:SRAM
unsigned char gEEPRomType;
unsigned char gCartType;
unsigned long gRomSize;
unsigned long gRomBlkSize;
unsigned char gMBC1Exp;
unsigned char gWriteFirst;
unsigned char gErase;

// Wait constant 1ticks = 2.5us
#define WAIT_1MS		200

// GBA Power sense bit of port-c
#define STATUS_DOWNLOAD	0
#define STATUS_UPLOAD	1
#define	ACCESS_ROM		0
#define ACCESS_SRAM		1

#define MEMORY_ALIGNMENT	4

#define EMPTY			0

#define FLASH4M_SIZE	512*1024
#define FLASH16M_SIZE	2*1024*1024
#define FLASH64M_SIZE	8*1024*1024
#define FLASH4M_BLOCK	512*1024
#define FLASH16M_BLOCK	0x00020000
#define FLASH64M_BLOCK	0x00020000

#define RETRY_TIME_MX	3
#define RETRY_TIME_WIN	16

#define RLED_ON			0x10
#define WLED_ON			0x20
#define LED_OFF			0x00
